using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;

using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;

namespace MultiplePages
{
    public partial class Form1 : Form
    {
        private RectangleF rectf;
        private RectangleF bounds;
        private float x = 0.0f,y=0.0f;
        private Font f ;
        private PdfFont font;
        private PdfStringFormat format = new PdfStringFormat();
        private SizeF sizef;
        
        private float headerH = 0.0f, footerH = 0.0f, bodyH = 0.0f;
        string filename = Path.Combine(Path.GetTempPath(), "sample.pdf");
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            
            PdfDocument doc = new PdfDocument();
            doc.PageSettings.SetMargins(50, 50, 50, 50);
            PdfPage page = doc.Pages.Add();
            
            string str = "My time Pharamacy India pvt.Ltd.\n Ground Floor,\n somajiguda circle\n Hyderabad";
            this.DrawHeader(doc, str,page);
            str = string.Empty;
            str = "Benefits announced by the company from time to time \n Conditions Apply";
            this.DrawFooter(doc, str,page);
            str = string.Empty;
            str = "Threads are relatively lightweight processes responsible for multitasking within a single "
                  + "application. The System.Threading namespace provides a wealth of classes and interfaces to "
                  + "manage multithreaded programming. The majority of programmers might never need to manage "
                  + "threads explicitly, however, because the Common Language Runtime (CLR) abstracts much of the "
                  + "threading support into classes that greatly simplify most threading tasks. For example, "
                  + " you will see how to create multithreaded reading and writing streams without resorting to "
                  + "managing the threads yourself.";
            sizef = font.MeasureString(str);
            //rectf = new RectangleF(new PointF(x,headerH),sizef);
            rectf = new RectangleF(x,y, page.Graphics.ClientSize.Width, page.Graphics.ClientSize.Height);
           // PdfGraphics pdfG = page.Graphics;
            bounds = rectf;
            font  = new PdfStandardFont(PdfFontFamily.Helvetica,10f);
            format = new PdfStringFormat();
            format.Alignment = PdfTextAlignment.Justify;

            PdfTextElement textElement = new PdfTextElement(str, font);
            textElement.Brush = new PdfSolidBrush(Color.Black);
            textElement.StringFormat = format;

            PdfLayoutFormat layoutFormat = new PdfLayoutFormat();
            layoutFormat.Break = PdfLayoutBreakType.FitPage;
            layoutFormat.Layout = PdfLayoutType.Paginate;

            PdfTextLayoutResult textLResult = textElement.Draw(page,bounds,layoutFormat);

            textElement = new PdfTextElement(str, font);
            textElement.Brush = new PdfSolidBrush(Color.Chocolate);
            textElement.StringFormat = format;

            bounds.Y = textLResult.LastLineBounds.Y + 20f;

            textLResult = textElement.Draw(page, bounds, layoutFormat);

            textElement = new PdfTextElement(str, font);
            textElement.Brush = new PdfSolidBrush(Color.CadetBlue);
            textElement.StringFormat = format;
            bounds.Y = textLResult.LastLineBounds.Y + 20f;

            textLResult = textElement.Draw(page, bounds, layoutFormat);
            textElement = new PdfTextElement(str, font);
            textElement.Brush = new PdfSolidBrush(Color.Brown);
            textElement.StringFormat = format;
            bounds.Y = textLResult.LastLineBounds.Y + 20f;
            textLResult = textElement.Draw(page, bounds, layoutFormat);
            
            textElement = new PdfTextElement(str, font);
            textElement.Brush = new PdfSolidBrush(Color.Crimson);
            textElement.StringFormat = format;
            bounds.Y = textLResult.LastLineBounds.Y + 20f;
            textLResult = textElement.Draw(page, bounds, layoutFormat);
            
            textElement = new PdfTextElement(str, font);
            textElement.Brush = new PdfSolidBrush(Color.DarkCyan);
            textElement.StringFormat = format;
            bounds.Y = textLResult.LastLineBounds.Y + 20f;
            textLResult = textElement.Draw(page, bounds, layoutFormat);
            
            textElement = new PdfTextElement(str, font);
            textElement.Brush = new PdfSolidBrush(Color.DarkGoldenrod);
            textElement.StringFormat = format;
            bounds.Y = textLResult.LastLineBounds.Y + 20f;
            textLResult = textElement.Draw(page, bounds, layoutFormat);
            
            textElement = new PdfTextElement(str, font);
            textElement.Brush = new PdfSolidBrush(Color.DarkKhaki);
            textElement.StringFormat = format;
            bounds.Y = textLResult.LastLineBounds.Y + 20f;
            textLResult = textElement.Draw(page, bounds, layoutFormat);
 
            doc.Save(filename);
            System.Diagnostics.Process.Start(filename);
        }

        private void DrawHeader(PdfDocument doc, string str,PdfPage page)
        {
            rectf = new RectangleF(x, y, doc.Pages[0].GetClientSize().Width, 200);
            PdfPageTemplateElement header = new PdfPageTemplateElement(rectf);
            f = new Font("Arial", 24, FontStyle.Bold);
            font = new PdfTrueTypeFont(f);
            sizef = font.MeasureString(str);
            format.Alignment = PdfTextAlignment.Left;
            format.LineAlignment = PdfVerticalAlignment.Top;
            format.WordWrap = PdfWordWrapType.Character;
            format.LineLimit = true;
            header.Graphics.DrawString(str,font,PdfBrushes.BlueViolet,new RectangleF(page.Size.Width/2, 0, header.Width,header.Height), format);
            doc.Template.Top = header;
            headerH = sizef.Height;
        }

        private void DrawFooter(PdfDocument doc, string str, PdfPage page)
        {
            rectf = new RectangleF(x, y, doc.Pages[0].GetClientSize().Width,34);
            PdfPageTemplateElement footer = new PdfPageTemplateElement(rectf);
            f = new Font("Arial",10, FontStyle.Regular);
            font = new PdfTrueTypeFont(f);
            sizef = font.MeasureString(str);
            format.Alignment = PdfTextAlignment.Center;
            format.LineAlignment = PdfVerticalAlignment.Middle;
            format.WordWrap = PdfWordWrapType.None;
            format.NoClip = true;
            PdfSolidBrush brush = new PdfSolidBrush(Color.Black);

            footer.Graphics.DrawString(str, font,brush, new RectangleF(0, 0, footer.Width,footer.Height), format);
            //Drawing Line
            PdfPen pen = new PdfPen(Color.Black, 1.0f);
            footer.Graphics.DrawLine(pen, 0, 0, footer.Width, 0);
            doc.Template.Bottom = footer;
            footerH = footer.Height;
        }
    }
}